unit MySystemGlobals;

interface

	uses
		Quickdraw, Files;

	var  { set up by InitSystemGlobals }
		system7: boolean;
		system_version: longInt;
		has_appleEvents: boolean;
		has_findfolder: boolean;
		has_aliasMgr: boolean;
		has_newStdFile: boolean;
		has_HelpMgr: boolean;
		has_colorQD: boolean;
		has_DragManager: boolean;
		has_ThreadManager: boolean;
		app_resfile: integer;
		app_fs: FSSpec;

	procedure InitSystemGlobals;
	function RefNumToFSSpec(rn:integer; var fs:FSSpec):OSErr;
	
implementation

	uses
		Resources, GestaltEqu;

	function RefNumToFSSpec(rn:integer; var fs:FSSpec):OSErr;
		var
			pb: FCBPBRec;
	begin
		pb.ioNamePtr := @fs.name;
		pb.ioVRefNum := 0;
		pb.ioRefNum := rn;
		pb.ioFCBIndx := 0;
		RefNumToFSSpec := PBGetFCBInfoSync(@pb);
		fs.vRefNum := pb.ioFCBVRefNum;
		fs.parID := pb.ioFCBParID;
	end;
	
	procedure InitSystemGlobals;
		var
			oe: OSErr;
			gv: longInt;
			sysenv: sysEnvRec;
	begin
		app_resfile := CurResFile;
		oe := RefNumToFSSpec(app_resfile, app_fs);
		has_colorqd := (SysEnvirons(1, sysEnv) = noErr) & sysenv.hasColorQD; { Gestalt has a bug that causes hasColourQD to always be set }
		if (Gestalt(gestaltSystemVersion, system_version) <> noErr) then begin
			system_version := $0600;
		end;
		system7 := system_version >= $0700;
		has_AppleEvents := (Gestalt(gestaltAppleEventsAttr, gv) = noErr) & (BTST(gv, gestaltAppleEventsPresent));
		has_findfolder := (Gestalt(gestaltFindFolderAttr, gv) = noErr) & (BTST(gv, gestaltFindFolderPresent));
		has_newStdFile := (Gestalt(gestaltStandardFileAttr, gv) = noErr) & (BTST(gv, gestaltStandardFile58));
		has_HelpMgr := (Gestalt(gestaltHelpMgrAttr, gv) = noErr) & (BTST(gv, gestaltHelpMgrPresent));
		has_aliasMgr := (Gestalt(gestaltAliasMgrAttr, gv) = noErr) & (BTST(gv, gestaltAliasMgrPresent));
		has_DragManager := (Gestalt(gestaltDragMgrAttr, gv) = noErr) & (BTST(gv, gestaltDragMgrPresent));
		has_ThreadManager := (Gestalt(gestaltThreadMgrAttr, gv) = noErr) & (BTST(gv, gestaltThreadMgrPresent));
	end;

end.